Index: anuga_work/publications/anuga_2007/anuga_validation.tex
===================================================================
--- anuga_work/publications/anuga_2007/anuga_validation.tex	(revision 5678)
+++ anuga_work/publications/anuga_2007/anuga_validation.tex	(revision 5679)
@@ -563,6 +563,6 @@
 period range of 0.3 - 7.0 seconds. 
 
-Four tests with different combinations of wave height and wave period
-were used, with each test being repeated once.
+Four scenarios with different combinations of wave height and wave period
+were used, with each scenario being repeated once.
 
 A variety of measurements were taken during the simulation.  Mid-depth
@@ -572,5 +572,5 @@
 determined the location of breaking waves. All the tests produced 4 to
 7 waves.  Generally the first wave did not break, with subsequent
-waves breaking; accept for T2R1 and T2R2, for which the first 3 waves
+waves breaking; accept for scenario 2, for which the first 3 waves
 did not break.
 
@@ -585,12 +585,12 @@
     Test Name & Beach slope nominal, \emph{degrees}   & Water depth offshore,
     \emph{mm } & Wave frequency nominal, \emph{Hz}  \\ \hline
-    T1R1 & 3.5 & 400 & 0.200 \\ \hline
-    T1R2 & 3.5 & 400 & 0.200 \\ \hline
-    T2R1 & 3.5 & 400 & 0.125 \\ \hline
-    T2R2 & 3.5 & 400 & 0.125 \\ \hline
-    T3R1 & 1.5 & 336 & 0.200 \\ \hline
-    T3R2 & 1.5 & 336 & 0.200 \\ \hline
-    T4R1 & 1.5 & 336 & 0.125 \\ \hline
-    T4R2 & 1.5 & 336 & 0.125 \\ \hline
+    S1R1 & 3.5 & 400 & 0.200 \\ \hline
+    S1R2 & 3.5 & 400 & 0.200 \\ \hline
+    S2R1 & 3.5 & 400 & 0.125 \\ \hline
+    S2R2 & 3.5 & 400 & 0.125 \\ \hline
+    S3R1 & 1.5 & 336 & 0.200 \\ \hline
+    S3R2 & 1.5 & 336 & 0.200 \\ \hline
+    S4R1 & 1.5 & 336 & 0.125 \\ \hline
+    S4R2 & 1.5 & 336 & 0.125 \\ \hline
     
     % Mapping of new names to old names
@@ -624,71 +624,68 @@
 \]
 
-Figures \ref{fig:T1-rmsd} to \ref{fig:T4-rmsd} show the RMSD of all
-the sensors in four tests and the location where each wave broke.
- 
- Figures \ref{fig:T1-rmsd} to \ref{fig:T4-rmsd} show the RMSD of each
+ Figures \ref{fig:S1-rmsd} to \ref{fig:S4-rmsd} show the RMSD of each
  sensor in four tests and the location where each wave broke.  The
  RMSD is calculated over the time of the experiment.
  
 \begin{figure}[htbp]
-\centerline{\includegraphics[width=4in]{T1-rmsd}}
-\caption{RMSD of stage between the wave tank and ANUGA for T1R1 and T1R2}
-\label{fig:T1-rmsd}
-\end{figure}
-
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=4in]{T2-rmsd}}
-\caption{RMSD of stage between the wave tank and ANUGA for T2R1 and T2R2}
-\label{fig:T2-rmsd}
-\end{figure}
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=4in]{T3-rmsd}}
-\caption{RMSD of stage between the wave tank and ANUGA for T3R1 and T3R2}
-\label{fig:T3-rmsd}
-\end{figure}
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=4in]{T4-rmsd}}
-\caption{RMSD of stage between the wave tank and ANUGA for T4R1 and T4R2}
-\label{fig:T4-rmsd}
+\centerline{\includegraphics[width=4in]{S1-rmsd}}
+\caption{RMSD of stage between the wave tank and ANUGA for S1R1 and S1R2}
+\label{fig:S1-rmsd}
+\end{figure}
+
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=4in]{S2-rmsd}}
+\caption{RMSD of stage between the wave tank and ANUGA for S2R1 and S2R2}
+\label{fig:S2-rmsd}
+\end{figure}
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=4in]{S3-rmsd}}
+\caption{RMSD of stage between the wave tank and ANUGA for S3R1 and S3R2}
+\label{fig:S3-rmsd}
+\end{figure}
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=4in]{S4-rmsd}}
+\caption{RMSD of stage between the wave tank and ANUGA for S4R1 and S4R2}
+\label{fig:S4-rmsd}
 \end{figure}
 
 For a more direct comparision between the simulation and the
 experiment the stages at three gauges, generally the initial, final
-and worst fit, were compared in Figures \ref{fig:T1-stage-compare} to
-\ref{fig:T4-stage-compare}.
-
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=5in]{T1-stage-compare}}
+and worst fit, were compared in Figures \ref{fig:S1-stage-compare} to
+\ref{fig:S4-stage-compare}.
+
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=5in]{S1-stage-compare}}
 \caption{Comparison of wave tank (solid line) and ANUGA (broken line)
-  water stages at three gauges for T1R1.}
-\label{fig:T1-stage-compare}
-\end{figure}
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=5in]{T2-stage-compare}}
+  water stages at three gauges for S1R1.}
+\label{fig:S1-stage-compare}
+\end{figure}
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=5in]{S2-stage-compare}}
 \caption{Comparison of wave tank (solid line) and ANUGA (broken line)
  water stages at three
-  gauges for T2R1.}
-\label{fig:T2-stage-compare}
-\end{figure}
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=5in]{T3-stage-compare}}
+  gauges for S2R1.}
+\label{fig:S2-stage-compare}
+\end{figure}
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=5in]{S3-stage-compare}}
 \caption{Comparison of wave tank (solid line) and ANUGA (broken line)
  water stages at three
-  gauges for T3R1.}
-\label{fig:T3-stage-compare}
-\end{figure}
-
-\begin{figure}[htbp]
-\centerline{\includegraphics[width=5in]{T4-stage-compare}}
+  gauges for S3R1.}
+\label{fig:S3-stage-compare}
+\end{figure}
+
+\begin{figure}[htbp]
+\centerline{\includegraphics[width=5in]{S4-stage-compare}}
 \caption{Comparison of wave tank (solid line) and ANUGA (broken line)
  water stages at three
-  gauges for T4R1.}
-\label{fig:T4-stage-compare}
+  gauges for S4R1.}
+\label{fig:S4-stage-compare}
 \end{figure}
 