Index: /anuga_work/development/anuga_1d/compile_all.py
===================================================================
--- /anuga_work/development/anuga_1d/compile_all.py	(revision 5728)
+++ /anuga_work/development/anuga_1d/compile_all.py	(revision 5728)
@@ -0,0 +1,21 @@
+import os
+
+buildroot = os.getcwd()
+
+#Attempt to compile all extensions
+
+anuga_dir = '..' + os.sep + '..' + os.sep + '..'
+#os.chdir(anuga_dir)
+print os.getcwd()  
+
+utilities_dir = anuga_dir + os.sep + 'anuga_core' + os.sep + 'source' + os.sep + 'anuga' + os.sep + 'utilities'
+
+print anuga_dir
+print utilities_dir
+execfile( utilities_dir + os.sep + 'compile.py')
+
+
+
+os.chdir(buildroot)    
+#execfile('test_all.py')
+    
Index: /anuga_work/development/anuga_1d/dam_h_elevation.py
===================================================================
--- /anuga_work/development/anuga_1d/dam_h_elevation.py	(revision 5727)
+++ /anuga_work/development/anuga_1d/dam_h_elevation.py	(revision 5728)
@@ -1,5 +1,5 @@
 import os
 from math import sqrt, sin, cos, pi, exp
-from shallow_water_domain import *
+from shallow_water_domain_new import *
 from Numeric import zeros, Float
 #from analytic_dam_sudi import AnalyticDam
@@ -138,7 +138,8 @@
         #pass
     
-        from pylab import plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot,ion
+        from pylab import clf,plot,title,xlabel,ylabel,legend,savefig,show,hold,subplot,ion
         #print 'Test1'
-        hold(False)
+        #hold(False)
+        clf()
         #print 'test 2'
         plot1 = subplot(211)
@@ -150,6 +151,8 @@
         xlabel('Position')
         ylabel('Stage')
-        legend( ('Bed Elevation', 'Numerical Solution'),
-           'upper right', shadow=False)
+        #legend( ('Bed Elevation', 'Numerical Solution'),
+        #   'upper right', shadow=False)
+
+        
         #legend(('Analytical Solution', 'Numerical Solution'),
         #   'lower right', shadow=False)
@@ -157,6 +160,6 @@
         plot(X,MomentumQ)
         #plot2.set_ylim([-5,35])
-        legend( ('Numerical Solution', 'for momentum'),
-           'upper right', shadow=False)
+        #legend( ('Numerical Solution', 'for momentum'),
+        #   'upper right', shadow=False)
     
         xlabel('Position')
@@ -168,4 +171,4 @@
         #savefig(file)
         show()
-
+        
 print 'That took %.2f seconds'%(time.time()-t0)
Index: /anuga_work/development/anuga_1d/test_shallow_water.py
===================================================================
--- /anuga_work/development/anuga_1d/test_shallow_water.py	(revision 5727)
+++ /anuga_work/development/anuga_1d/test_shallow_water.py	(revision 5728)
@@ -5,8 +5,8 @@
 
 
-from shallow_water_domain import *
-from shallow_water_domain import flux_function as domain_flux_function
-
-from Numeric import allclose, array, ones, Float
+from shallow_water_domain_new import *
+from shallow_water_domain_new import flux_function as domain_flux_function
+
+from Numeric import allclose, array, ones, Float, maximum
 
 
@@ -15,4 +15,5 @@
         self.points = [0.0, 1.0, 2.0, 3.0]
         self.vertex_values = [[1.0,2.0],[4.0,5.0],[-1.0,2.0]]
+        self.points2 = [0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0]
         
     def tearDown(self):
@@ -123,14 +124,14 @@
         """
 		
-	def slope_one(x):
-            return x
+	def slope_square(x):
+            return maximum(4.0-(x-5.0)*(x-5.0), 0.0)
 			
-        domain = Domain(self.points)
-        domain.set_quantity('stage',4.0)
-	domain.set_quantity('elevation',slope_one)
+        domain = Domain(self.points2)
+        domain.set_quantity('stage',10.0)
+	domain.set_quantity('elevation',slope_square)
         domain.set_boundary({'exterior' : Reflective_boundary(domain)})
 
-        yieldstep=0.01
-        finaltime=0.01
+        yieldstep=10.0
+        finaltime=10.0
 
         for t in domain.evolve(yieldstep=yieldstep, finaltime=finaltime):
@@ -146,5 +147,5 @@
         print domain.quantities['xmomentum'].centroid_values    
 
-        assert allclose( array([-34.3, -24.5, -14.7], Float), domain.quantities['xmomentum'].explicit_update )
+        #assert allclose( array([-34.3, -24.5, -14.7], Float), domain.quantities['xmomentum'].explicit_update )
 
 