Index: /anuga_work/development/anuga_1d/dam_h_elevation.py
===================================================================
--- /anuga_work/development/anuga_1d/dam_h_elevation.py	(revision 5736)
+++ /anuga_work/development/anuga_1d/dam_h_elevation.py	(revision 5737)
@@ -61,5 +61,5 @@
     for i in range(len(x)):
         if 1100.0 <= x[i] <=1200.0:
-            y[i]=10.0
+            y[i]=10.001
         else:
             y[i]=10.0
@@ -106,6 +106,6 @@
     return y
 
-domain.set_quantity('stage',stage)
-domain.set_quantity('elevation', elevation_box)
+domain.set_quantity('stage',stage_perturb)
+domain.set_quantity('elevation', elevation_parabol)
 #domain.set_quantity('xmomentum', xmom_sincos)
 domain.order=domain.default_order
@@ -122,5 +122,5 @@
 import time
 t0=time.time()
-yieldstep=0.5 #30.0
+yieldstep=10.0 #30.0
 finaltime=10.0 #20.0
 print "integral", domain.quantities['stage'].get_integral()
Index: /anuga_work/development/anuga_1d/domain.py
===================================================================
--- /anuga_work/development/anuga_1d/domain.py	(revision 5736)
+++ /anuga_work/development/anuga_1d/domain.py	(revision 5737)
@@ -24,8 +24,8 @@
         self.coordinates = array(coordinates)
 
-##        if geo_reference is None:
-##            self. = Geo_reference() #Use defaults 
-##        else:
-##            self.geo_reference = geo_reference
+# #        if geo_reference is None:
+# #            self. = Geo_reference() #Use defaults 
+# #        else:
+# #            self.geo_reference = geo_reference
 
         #Register number of Elements
@@ -76,8 +76,8 @@
             self.areas[i] = (xr-xl)
             
-##         print 'N', N
-##         print 'Centroid', self.centroids
-##         print 'Areas', self.areas
-##         print 'Vertex_Coordinates', self.vertices
+# #         print 'N', N
+# #         print 'Centroid', self.centroids
+# #         print 'Areas', self.areas
+# #         print 'Vertex_Coordinates', self.vertices
             
             #Initialise Neighbours (-1 means that it is a boundary neighbour)
@@ -554,8 +554,8 @@
         #from quantity import Quantity, Conserved_quantity
         #Create appropriate quantity object
-        ##if name in self.conserved_quantities:
-        ##    self.quantities[name] = Conserved_quantity(self)
-        ##else:
-        ##    self.quantities[name] = Quantity(self)
+        # #if name in self.conserved_quantities:
+        # #    self.quantities[name] = Conserved_quantity(self)
+        # #else:
+        # #    self.quantities[name] = Quantity(self)
 
 
@@ -617,9 +617,4 @@
 
         self.boundary_objects = []
-        
-
-
-
-        
         self.boundary_map = boundary_map  #Store for use with eg. boundary_stats.
 
@@ -664,5 +659,5 @@
             assert quantity in self.quantities, msg
 
-        ##assert hasattr(self, 'boundary_objects')
+        # #assert hasattr(self, 'boundary_objects')
 
     def write_time(self):
@@ -725,5 +720,5 @@
         assert hasattr(self, 'boundary_objects'), msg
 
-        ##self.set_defaults()
+        # #self.set_defaults()
 
         if yieldstep is None:
@@ -780,5 +775,5 @@
             elif self.time_order == 2:
                 
-                self.compute_timestep()
+                self.compute_timestep() #self.compute_fluxes() !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
                 #Solve inhomogeneous operator for half a timestep
@@ -989,5 +984,5 @@
                 Q = self.quantities[name]
                 Q.boundary_values[i] = q[j]
-
+    
     def update_timestep(self, yieldstep, finaltime):
 
@@ -1040,5 +1035,5 @@
 
         self.timestep = timestep
-
+    
 
     def compute_forcing_terms(self):
@@ -1111,3 +1106,2 @@
     #points2 = [0.0, 1.0, 2.0, 3.0, 2.5]
     #D2 = Domain(points2)
-
Index: /anuga_work/development/anuga_1d/shallow_water_domain_new.py
===================================================================
--- /anuga_work/development/anuga_1d/shallow_water_domain_new.py	(revision 5736)
+++ /anuga_work/development/anuga_1d/shallow_water_domain_new.py	(revision 5737)
@@ -154,5 +154,5 @@
         #Call correct module function
         #(either from this module or C-extension)
-        compute_fluxes_C_short(self) #compute_fluxes_C_wellbalanced(self) #compute_fluxes_C_short(self)  #compute_fluxes_C_long(self)
+        compute_fluxes_C_short(self)    #compute_fluxes_C_wellbalanced(self)     #compute_fluxes(self)  #compute_fluxes_C_long(self)
 
     def compute_timestep(self):
@@ -545,5 +545,5 @@
                                   max_speed_array)
 
-####################################
+# ###################################
 
 
@@ -763,5 +763,5 @@
 
 
-###############################################
+# ##############################################
 #Boundaries - specific to the shallow water wave equation
 class Reflective_boundary(Boundary):
@@ -837,5 +837,5 @@
 
 
-#########################
+# ########################
 #Standard forcing terms:
 def gravity(domain):